; 
    .486                       ; create 32 bit code
    .model flat, stdcall       ; 32 bit memory model
    option casemap :none       ; case sensitive
 
    include \masm32\include\windows.inc
    include \masm32\include\masm32.inc
    include \masm32\include\user32.inc
    include \masm32\include\_kernel32.inc
    includelib \masm32\lib\masm32.lib
    includelib \masm32\lib\user32.lib
    includelib \masm32\lib\_kernel32.lib
    include \masm32\macros\macros.asm
; 
    .data      
      hConsoleOutput  dd 0
      max_coord       COORD <>
      small_rect      SMALL_RECT <>
      csbi            CONSOLE_SCREEN_BUFFER_INFO <>
    .code
; 
start:
; 
    invoke GetStdHandle,STD_OUTPUT_HANDLE
    mov   hConsoleOutput,eax

    invoke GetConsoleScreenBufferInfo,hConsoleOutput,ADDR csbi
    print chr$("console screen buffer rows = ")
    movzx eax,csbi.dwSize.y
    print ustr$(eax)
    print chr$(13,10,"console screen buffer cols = ")
    movzx eax,csbi.dwSize.x
    print ustr$(eax)
    print chr$(13,10,13,10,"console window left = ")
    movzx eax,csbi.srWindow.Left
    print ustr$(eax)
    print chr$(13,10,"console window top = ")
    movzx eax,csbi.srWindow.Top
    print ustr$(eax)
    print chr$(13,10,"console window right = ")
    movzx eax,csbi.srWindow.Right
    print ustr$(eax)
    print chr$(13,10,"console window bottom = ")
    movzx eax,csbi.srWindow.Bottom
    print ustr$(eax)    

    invoke GetLargestConsoleWindowSize,hConsoleOutput
    mov   max_coord,eax
    print chr$(13,10,13,10,"largest console window rows = ")
    movzx eax,max_coord.y
    print ustr$(eax)
    print chr$(13,10,"largest console window cols = ")
    movzx eax,max_coord.x
    print ustr$(eax)

    mov   ax,csbi.dwSize.y
    shl   eax,16
    mov   ax,max_coord.x
    invoke SetConsoleScreenBufferSize,hConsoleOutput,eax
    
    invoke GetConsoleScreenBufferInfo,hConsoleOutput,ADDR csbi
    print chr$(13,10,13,10,"console screen buffer rows = ")
    movzx eax,csbi.dwSize.y
    print ustr$(eax)
    print chr$(13,10,"console screen buffer cols = ")
    movzx eax,csbi.dwSize.x
    print ustr$(eax)

    mov   eax,input(13,10,13,10,"Press enter to continue...")

    mov small_rect.Left,0
    mov small_rect.Top,0
    mov ax,max_coord.x
    dec ax
    mov small_rect.Right,ax
    mov ax,max_coord.y
    dec ax
    mov small_rect.Bottom,ax
    invoke SetConsoleWindowInfo,hConsoleOutput,TRUE,ADDR small_rect

    invoke GetConsoleScreenBufferInfo,hConsoleOutput,ADDR csbi
    print chr$(13,10,"console window left = ")
    movzx eax,csbi.srWindow.Left
    print ustr$(eax)
    print chr$(13,10,"console window top = ")
    movzx eax,csbi.srWindow.Top
    print ustr$(eax)
    print chr$(13,10,"console window right = ")
    movzx eax,csbi.srWindow.Right
    print ustr$(eax)
    print chr$(13,10,"console window bottom = ")
    movzx eax,csbi.srWindow.Bottom
    print ustr$(eax)

    mov   eax,input(13,10,13,10,"Press enter to continue...")

    print chr$(13,10,"GetModuleHandle: ")
    invoke GetModuleHandle,NULL
    print uhex$(eax)
    print chr$(13,10)    

    call GetConsoleWindow
    mov   ebx,eax

    print chr$("GetConsoleWindow: ")
    print uhex$(ebx)    

    ;invoke ShowWindow,ebx,WS_MAXIMIZE   ; does not work
    invoke ShowWindow,ebx,SW_MAXIMIZE

    invoke GetConsoleScreenBufferInfo,hConsoleOutput,ADDR csbi
    print chr$(13,10,13,10,"console window left = ")
    movzx eax,csbi.srWindow.Left
    print ustr$(eax)
    print chr$(13,10,"console window top = ")
    movzx eax,csbi.srWindow.Top
    print ustr$(eax)
    print chr$(13,10,"console window right = ")
    movzx eax,csbi.srWindow.Right
    print ustr$(eax)
    print chr$(13,10,"console window bottom = ")
    movzx eax,csbi.srWindow.Bottom
    print ustr$(eax)

    mov   eax,input(13,10,13,10,"Press enter to exit...")
    exit
; 
end start